﻿Imports System.Runtime.CompilerServices

Namespace System.Windows.Forms

   Public Module TabControlX

      ''' <summary>
      ''' Dieser Schwachsinn im Form_Load ausgeführt behebt einen Bug beim DataBinding auf beim Start nicht sichtbaren Tabpages.
      ''' </summary>
      <Extension()> _
      Public Sub InitBindability(tc As TabControl)
         Dim parent = tc.FindForm
         parent.SuspendLayout()
         For Each tp As TabPage In tc.TabPages
            tp.SuspendLayout()
            For Each ctl In tp.Controls.Cast(Of Control).ToArray
               parent.Controls.Add(ctl)
               tp.Controls.Add(ctl)
            Next
            tp.ResumeLayout()
         Next
         parent.ResumeLayout()
      End Sub

      ''' <summary>hides Riders of TabControl</summary>
      <Extension()> _
      Public Sub HideRiders(tc As TabControl)
         tc.SuspendLayout()
         tc.SizeMode = TabSizeMode.Fixed
         tc.ItemSize = New Size(0, 1)
         tc.Appearance = TabAppearance.Buttons
         tc.ResumeLayout()
      End Sub

      <Extension()> _
      Public Sub AddUserControls(tc As TabControl, ParamArray ucls() As UserControl)
         tc.SuspendLayout()
         For i = 1 To ucls.Length
            Dim ucl = ucls(i - 1)
            Dim txt = If(TryCast(ucl.Tag, String), "TabPage" & i)
            Dim tp = New TabPage With {.Text = txt}
            ucl.Dock = DockStyle.Fill
            tp.Controls.Add(ucl)
            tc.TabPages.Add(tp)
         Next
         tc.ResumeLayout()
      End Sub

   End Module

End Namespace
